#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

// Ce programme montre le fonctionnement de malloc vs sbrk.
// * brk/sbrk changent la taille du mémoire virtuel allouée au processus
// * malloc cherche une place libre dans le tas du mémoire virtuel
//   et l'élargit (à l'aide de brk) si nécessaire.
// Observer le comportement avec ltrace et strace.

int main()
{
	void *sb = sbrk(0);
	printf("beginning, sbrk=%p\n",sb);
	
	for (int i = 1; i <= 50; i++)
	{
		char *m = malloc(15000);
		void *nsb = sbrk(0);
		printf("round #%2d, sbrk=%p",i,nsb);
		if (sb != nsb) printf(" (change of %ld)",nsb-sb);
		printf("\n");
		sb = nsb;
	}
}
